#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <string>

#include "rts_forest.hpp"
#include "common.h"

int main(int argc, char *argv[]){

	//
	// Randomized Forest ̓ǂݍ
	//

	RTs::Forest rts_forest;
	if(rts_forest.Load("../Regression_Forests.txt") == false){
		std::cerr << "RTs::Forest::Load() failed." << std::endl;
		std::cerr.flush();
		return 1;
	}

	//
	// Tvf[^̓ǂݍ & ʃeXg
	//

	int sample_num = 0;
	double error = 0.0;

	std::stringstream ss;
	ss << "../resrc/Ragression_sample.txt";
	std::ifstream ifs(ss.str().c_str());

	if(!ifs){
		std::cout << "t@CJ܂ : " << ss.str().c_str() << std::endl;
		exit(-1);
	}

	while(!ifs.eof()){
		
		double tmp;
		RTs::Sample sample;
		sample.label_vec = 0.0;
		sample.feature_vec.resize(INPUT_DIM_SIZE);

		for(int i=0; i<INPUT_DIM_SIZE; i++){
			ifs >> tmp;
			sample.feature_vec[i] = tmp;
		}

		ifs >> tmp;
		sample.label_vec = tmp;
		

		if(ifs.fail()){
			break;
		}

		sample_num++;
		
		std::cout << sample_num << "\tINPUT VEC = ";
		std::cout.flush();

		for(int i=0; i<INPUT_DIM_SIZE; i++){
			std::cout << sample.feature_vec[i] << " ";
		}

		std::cout << "\tOUTPUT VEC = ";
		std::cout.flush();

		std::cout << sample.label_vec << " ";

		//	Regression Forestsɂ\
		double prediction = rts_forest.EstimateClass(sample.feature_vec);
		if(prediction == NULL){
			std::cerr << "RTs::Forest::EstimateClass() failed." << std::endl;
			std::cerr.flush();
			return 1;
		}
		tmp = (prediction - sample.label_vec) * (prediction - sample.label_vec);
		error += tmp;

		std::cout << tmp << "\r";
		std::cout.flush();
	}

	std::cout << "A܂B\nerror = " << error << std::endl;
	std::cout.flush();

	return 0;
}
