#ifndef _RTS_FOREST_HPP_
#define _RTS_FOREST_HPP_

#include "rts_feature.hpp"
#include "rts_sample.hpp"
#include "rts_node.hpp"
#include "rts_tree.hpp"

namespace RTs{

//
// RTs::Forest ... ̌ (Tree) 𑩂˂NXD
//

class Forest{
private:
	int numTrees;        // ؂̐
	int maxDepth;        // ؂̍ő̐[
	int featureTrials;   // ʂ̃_I
	int thresholdTrials; // 臒l̃_I
	float dataPerTree;   // e Tree ɗ^鋳tM̃TuZbg̊
	double prediction;	 // e؂̗\

	std::vector<Tree *> trees; // 

public:
	// RXgN^
	Forest();

	// fXgN^
	~Forest();

	// tMɂ Randomized Forest 𐶐D
	bool Learn(const int _numTrees,
	           const int _maxDepth,
	           const int _featureTrials,
	           const int _thresholdTrials,
	           const float _dataPerTree,
	           std::vector<Sample> &samples);

	// ʑΏۂ̓xNgCΉqXgO߂D
	double EstimateClass(const Feature &feature_vec);

	// Forest Ŝۑ
	bool Save(const std::string &filename);

	// Forest Ŝǂ݂
	bool Load(const std::string &filename);

};

} // namespace RTs

#endif // _RTS_FOREST_HPP_
