#ifndef _RTS_NODE_HPP_
#define _RTS_NODE_HPP_

namespace RTs{

//
// RTs::Node ...  (Tree) \m[h̃NXDm[hƖ[m[ĥꂩɂȂD
//               m[hł *lChild  *rChild Ɏqm[h̃|C^ێD
//               [m[hł *distribution ɔzmۂāCqXgOێD
//

class Node{
public:
	bool flag;			 // false = leaf, true = split;
	int feature_id;      // feature
	float threshold;     // threshold
	std::vector<double> coefficient;	//	AW
	Node *lChild;        // left Child node
	Node *rChild;        // right Child node
	std::vector<const RTs::Sample *> samples;		 // \쐬p̃Tvz
	
	Node(){
		lChild = NULL;
		rChild = NULL;
	}
	
	~Node(){
		if(lChild != NULL){
			delete lChild;
		}
		if(rChild != NULL){
			delete rChild;
		}
	}

};

} // namespace RTs

#endif // _RTS_NODE_HPP_
